﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function () {
'use strict';
WinJS.Namespace.define("WeatherAppJS.Controls.Clusters", {
HeroClusterControl: WinJS.Class.derive(CommonJS.Immersive.ParallaxItemsContainer, function (element, options) {
/// <summary>A simple DIV container</summary>
/// <param name="element">DOM element</param>
/// <param name="options">Options struct</param>
var that = this;
element = this.element = element ? element : document.createElement("div");
element.winControl = this;
// Add this class to customize the hero width for weather app. 
WinJS.Utilities.addClass(element, "currentConditionsHero");
options.className = "currentConditionsHeroModule";
CommonJS.Immersive.ParallaxItemsContainer.call(this, element, options);
that.imageSize = {
width: 2117,
height: 1366
};
that.showGradient = true;
}, {
locId: null,
bypassCache: false,
isTianqi: false,
isFre: false,
_id: "WeatherAppJS.Controls.Clusters.HeroClusterControl",
uniqueRenderTag: null,
_isFirstRender: true,
_alertsPromise: null,
render: function render() {
var that = this;
var dataQuery;
var itemInfo = {
moduleInfo: {
isInteractive: true
}
};
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
if (that.isTianqi) {
itemInfo.moduleInfo.renderer = WeatherAppJS.Utilities.Templates.getTianQiTemplate;
dataQuery = WeatherAppJS.LocationsManager.getTianQiDataForLocationAsync;
} else {
itemInfo.moduleInfo.renderer = WeatherAppJS.Utilities.Templates.getCurrentConditionsTemplate;
dataQuery = WeatherAppJS.LocationsManager.getCCDataForLocationAsync;
}
return new WinJS.Promise(function (complete, error) {
dataQuery(that.locId, that.bypassCache, that.isFre).then(function (locObj) {
that.renderProxy(itemInfo, locObj).then(function () {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
complete();
});
}, function (e) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
complete();
}, function (locObj) {
that.renderProxy(itemInfo, locObj).then(function () {
complete();
});
});
}, function () {
WeatherAppJS.Controls.Utilities.cancelPromise(dataQuery);
WeatherAppJS.Controls.Utilities.cancelPromise(that._alertsPromise);
});
},
renderProxy: function renderProxy(itemInfo, locObj) {
var that = this;
var cc = locObj.getCurrentConditions();
if (cc.lastUpdatedTime === that.uniqueRenderTag) {
return WinJS.Promise.wrap(null);
}
// update last updated time on the page
var page = PlatformJS.Navigation.currentIPage;
if (page && page.displayLastUpdatedTime) {
page._lastUpdatedTime = cc.lastUpdatedTime;
page.displayLastUpdatedTime();
}
that.uniqueRenderTag = cc.lastUpdatedTime;
var iconCode = cc.iconcode;
var dayNightIndicator = cc.dayNightIndicator;
// Apply the theme and bind the hero image                
var container = document.getElementById('mainContainer');
if (container) {
WeatherAppJS.Utilities.ThemeManager.applyTheme(container, iconCode, dayNightIndicator);
}
var backgroundImage = WeatherAppJS.Utilities.ThemeManager.getHeroImageForSkyCode(iconCode, dayNightIndicator);
var anchorPoint = WeatherAppJS.Utilities.ThemeManager.getAnchorForSkyCode(iconCode, dayNightIndicator);
var datasource = new PlatformJS.Utilities.Binding.List();
itemInfo.loc = locObj;
datasource.push(itemInfo);
var parallaxRenderPromise;
if (that._isFirstRender) {
that.backgroundImage = backgroundImage;
that.anchorPoint = anchorPoint;
that.itemDataSource = datasource.dataSource;
parallaxRenderPromise = CommonJS.Immersive.ParallaxItemsContainer.prototype.render.call(that);
} else {
var model = {
backgroundImage: backgroundImage,
anchorPoint: anchorPoint,
itemDataSource: datasource.dataSource
};
parallaxRenderPromise = CommonJS.Immersive.ParallaxItemsContainer.prototype.refresh.call(that, model);
}
//ToDo: This is Bug In Existing code. Overide tabindex for currentCondition Module for HeroModule which is not necessary.
//var platformItemContainer = document.querySelector(".currentConditionsModule");
//if (platformItemContainer) {
//    platformItemContainer.tabIndex = -1;
//}
return parallaxRenderPromise.then(function () {
if (!that.isTianqi && !that.isFre) {
that._alertsPromise = WeatherAppJS.LocationsManager.getAlertsDataForLocationAsync(that.locId, that.bypassCache).then(null, function (e) { });
}
that._isFirstRender = false;
return WinJS.Promise.wrap(null);
});
},
onOrientationChange: function onOrientationChange(event) {
var uiUtilities = WeatherAppJS.Utilities.UI;
var viewManagement = Windows.UI.ViewManagement;
var layoutState = viewManagement.ApplicationView.value;
var forceMinimized = this.isTianqi;
var that = this;
// no animation required in limited experience, where we show only one provider data.
if (!uiUtilities.showLimitedExperience(that.locId)) {
uiUtilities.setHeroClusterState(layoutState, null, forceMinimized);
// enable/disable see more text based on whether it's visible or not
uiUtilities.setSeeMoreStatus(that.element, null, WeatherAppJS.SettingsManager.isCCMinimized(), layoutState);
}
// for landscape and filled, adjust hero based on resolution
var viewState = viewManagement.ApplicationViewState;
if (layoutState === viewState.fullScreenLandscape || layoutState === viewState.filled) {
uiUtilities.adjustHeroClusterForResolution(null, that.locId);
}
// update the anchorPoint based on orientation
var locObj = WeatherAppJS.LocationsManager.getLocation(that.locId);
if (locObj && locObj.getCurrentConditions()) {
var that = this;
var iconCode = locObj.getCurrentConditions().iconcode;
that.anchorPoint = WeatherAppJS.Utilities.ThemeManager.getAnchorForSkyCode(iconCode);
}
},
dispose: function dispose() {
this.cleanUp();
},
cleanUp: function cleanUp() {
var that = this;
if (that._isDisposed) {
return;
}
that._isDisposed = true;
CommonJS.Immersive.ParallaxItemsContainer.prototype.dispose.call(that);
that.element.innerHTML = "";
that.uniqueRenderTag = null;
},
}),
SkiResortsHeroClusterControl: WinJS.Class.derive(CommonJS.Immersive.ParallaxItemsContainer, function (element, options) {
/// <summary>A simple DIV container</summary>
/// <param name="element">DOM element</param>
/// <param name="options">Options struct</param>
var that = this;
element = this.element = element ? element : document.createElement("div");
element.winControl = this;
// Add this class to customize the hero width for weather app in portrait mode
WinJS.Utilities.addClass(element, "currentConditionsHero");
options.className = "currentConditionsHeroModule";
CommonJS.Immersive.ParallaxItemsContainer.call(this, element, options);            
that.imageSize = {
width: 2117,
height: 1366
};
that.showGradient = true;
}, {
locId: null,
bypassCache: false,
_id: "WeatherAppJS.Controls.Clusters.SkiResortsHeroClusterControl",
_anchorLandscape: null,
_anchorPortrait: null,
_isFirstRender: true,
_alertsPromise: null,
uniqueRenderTag: null,
render: function render() {
var that = this;
var skiDataPromise;
var itemInfo = {
moduleInfo: {
isInteractive: true
}
};
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
itemInfo.moduleInfo.renderer = WeatherAppJS.Utilities.Templates.getCurrentConditionsTemplate;
skiDataPromise = WeatherAppJS.LocationsManager.getSkiDetailsAsync(that.locId, that.bypassCache);
return new WinJS.Promise(function (complete, error) {
skiDataPromise.then(function (locObj) {
that.renderProxy(itemInfo, locObj).then(function () {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
complete();
});
}, function (e) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
complete();
}, function (locObj) {
that.renderProxy(itemInfo, locObj).then(function () {
complete();
});
});
}, function () {
WeatherAppJS.Controls.Utilities.cancelPromise(skiDataPromise);
WeatherAppJS.Controls.Utilities.cancelPromise(that._alertsPromise);
});
},
renderProxy: function renderProxy(itemInfo, locObj) {
var that = this;
var cc = locObj.getCurrentConditions();
if (cc.lastUpdatedTime === that.uniqueRenderTag) {
return WinJS.Promise.wrap(null);
}
// update last updated time on the page
var page = PlatformJS.Navigation.currentIPage;
if (page && page.displayLastUpdatedTime) {
page._lastUpdatedTime = cc.lastUpdatedTime;
page.displayLastUpdatedTime();
}                
that.uniqueRenderTag = cc.lastUpdatedTime;
var weatherData = locObj;
var skiHeroData = weatherData.getCurrentConditions();
that._anchorLandscape = skiHeroData.heroImageData.anchorPoint;
that._anchorPortrait = skiHeroData.heroImageData.anchorPointPortrait;
var backgroundImage = {
lowResolutionUrl: skiHeroData.heroImageData.lowResolutionUrl ? skiHeroData.heroImageData.lowResolutionUrl : skiHeroData.heroImageData.highResolutionUrl,
highResolutionUrl: skiHeroData.heroImageData.highResolutionUrl
};
var anchorPoint = that._getAnchor();
var attributionLabel = WeatherAppJS.Utilities.Common.getSkiAttributionData(cc);
var attributionData = { attributionText: attributionLabel, caption: "" };
var datasource = new PlatformJS.Utilities.Binding.List();
itemInfo.loc = weatherData;
datasource.push(itemInfo);
var parallaxRenderPromise;
if (that._isFirstRender) {
that.backgroundImage = backgroundImage;
that.anchorPoint = anchorPoint;
that.attributionData = attributionData;
that.itemDataSource = datasource.dataSource;
parallaxRenderPromise = CommonJS.Immersive.ParallaxItemsContainer.prototype.render.call(that);
} else {
var model = {
backgroundImage: backgroundImage,
anchorPoint: anchorPoint,
attributionData: attributionData,
itemDataSource: datasource.dataSource
};
parallaxRenderPromise = CommonJS.Immersive.ParallaxItemsContainer.prototype.refresh.call(that, model);
}
return parallaxRenderPromise.then(function () {
that._alertsPromise = WeatherAppJS.LocationsManager.getAlertsDataForLocationAsync(that.locId, that.bypassCache).then(null, function (e) { });
that._isFirstRender = false;
return WinJS.Promise.wrap(null);
});
},
onOrientationChange: function onOrientationChange(event) {
var uiUtilities = WeatherAppJS.Utilities.UI;
var viewManagement = Windows.UI.ViewManagement;
var layoutState = viewManagement.ApplicationView.value;
var that = this;
// no animation required in limited experience, where we show only one provider data.
if (!uiUtilities.showLimitedExperience(that.locId)) {
uiUtilities.setHeroClusterState(layoutState, null, true);
// enable/disable see more text based on whether it's visible or not
uiUtilities.setSeeMoreStatus(that.element, null, true, layoutState);
}
// for landscape and filled, adjust hero based on resolution
var viewState = viewManagement.ApplicationViewState;
if (layoutState === viewState.fullScreenLandscape || layoutState === viewState.filled) {
uiUtilities.adjustHeroClusterForResolution(null, that.locId);
}
// update the anchorPoint based on orientation
that.anchorPoint = that._getAnchor();
},
_getAnchor: function _getAnchor() {
var that = this;
var anchor;
if (Windows.UI.ViewManagement.ApplicationView.value === Windows.UI.ViewManagement.ApplicationViewState.fullScreenPortrait) {
anchor = that._anchorPortrait;
} else {
anchor = that._anchorLandscape;
}
return anchor;
},
dispose: function dispose() {
this.cleanUp();
},
cleanUp: function cleanUp() {
var that = this;
if (that._isDisposed) {
return;
}
that._isDisposed = true;
CommonJS.Immersive.ParallaxItemsContainer.prototype.dispose.call(that);
that.element.innerHTML = "";
that.uniqueRenderTag = null;
},
}),
});
})();