﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
'use strict';
// the namespace must be AppexJS.PreInitialize
WinJS.Namespace.define("AppexJS.PreInitialize", {
doMarketOverrides: function doMarketOverrides() {
var locationDominantMarketInfo = Platform.Globalization.Marketization.getDominantMarketForLocation();
var locationDominantMarketString = locationDominantMarketInfo.valueAsString;
var disablePrimaryLanguageOverride = true;
var geographicRegion = new Windows.Globalization.GeographicRegion();
if (locationDominantMarketInfo.geographicRegion && locationDominantMarketInfo.geographicRegion.codeTwoLetter === "CN") {
disablePrimaryLanguageOverride = false;
}
return {
// override the market string manually if desired
marketStringOverride: locationDominantMarketString,
disablePrimaryLanguageOverride: disablePrimaryLanguageOverride,
};
},
});
// The namespace used by Bing Maps SDK to avoid conflict with other SDKs.
window.$MapsNamespace = 'MicrosoftJS';
(function () {
PlatformJS.initialize();
WinJS.Application.start();
WinJS.UI.processAll();
WinJS.Resources.processAll();
})();
WinJS.Namespace.define("WeatherAppJS", {
WeatherBasePage: WinJS.Class.define(function (state) {
this._state = state || {};
var that = this;
WeatherAppJS.SettingsManager.addEventListener('settingchanged', this.onSettingsChangeBase, false);
}, {
_promisesStack: [],
_timersStack: [],
_timeoutsStack: [],
_state: null,
_lastUpdatedTime: null,
isImmersive: false,
displayLastUpdatedTime: function displayLastUpdatedTime() {
if (this._lastUpdatedTime) {
var timeStampDiv = document.querySelector(".lastUpdatedTimeStamp");
if (timeStampDiv) {
var ts = new Date(this._lastUpdatedTime);
var formatTimeStamp = PlatformJS.Services.resourceLoader.getString("LastUpdatedDataTime").format(WeatherAppJS.Utilities.Formatting.getFormattedLastUpdateTime(ts.getFullYear(), ts.getMonth(), ts.getDate(), ts.getHours(), ts.getMinutes(), ts.getSeconds()));
timeStampDiv.innerText = formatTimeStamp;
timeStampDiv.style.display = "block";
}
}
},
/// <summary>
/// hide lastupdated time stamp whem zoom in /out on worldweather maps
/// </summary>
hideLastUpdatedTime: function hideLastUpdatedTime() {
var timeStampdiv = document.querySelector(".lastUpdatedTimeStamp");
if (timeStampdiv) {
timeStampdiv.style.display = "none";
}
},
setPlatformTheme: function setPlatformTheme(theme) {
CommonJS.setTheme(theme, true);
},
/// <summary>
/// This function cleans up all the timers registered by the page
/// </summary>
cleanPeriodicTimersStack: function cleanPeriodicTimersStack() {
while (this._timersStack.length > 0) {
var timer = this._timersStack.pop();
if (timer) {
clearInterval(timer);
timer = null;
}
}
},
/// <summary>
/// This function cleans up all the timers registered by the page
/// </summary>
cleanTimeoutsStack: function cleanTimeoutsStack() {
while (this._timeoutsStack.length > 0) {
var timer = this._timeoutsStack.pop();
if (timer) {
clearTimeout(timer);
timer = null;
}
}
},        
/// <summary>
/// method that handles the 'settingschange' event
/// </summary>
onSettingsChangeBase: function onSettingsChangeBase(e) {
var currentPage = PlatformJS.Navigation.currentIPage;
if (currentPage.onSettingsChange && currentPage.onSettingsChange instanceof Function) {
currentPage.onSettingsChange(e);
}
},
/// <summary>
/// method that handles page refresh
/// </summary>
onPageRefresh: function onPageRefresh(e) {
},
/// <summary>
/// This function is invoked on navigate away.
/// We clean up our promises, timers, registered callbacks which are common across all pages.
/// The page can choose to have a _disposePage method to clean up page-specific objects.
/// </summary>
disposePage: function disposePage() {
WeatherAppJS.Utilities.Common.cleanupPromiseStack(this._promisesStack);
this.cleanPeriodicTimersStack();
this.cleanTimeoutsStack();
WeatherAppJS.SettingsManager.removeEventListener('settingchanged', this.onSettingsChangeBase);
if (this._disposePage) {
this._disposePage();
}
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away
/// </summary>
/// <param name="reason">
/// The reason why the page is being navigated away: "backNavigation" or "newNavigation"
/// </param>
onNavigateAway: function onNavigateAway(reason) {
this.disposePage();
},
/// <summary>
/// This function when a layoutchange event is triggered (example: switch to snap mode).
/// We call page dispose for all pages since we have a seperate snap page implementation.
/// </summary>
onLayoutChange: function onLayoutChange(layoutState) {
var that = this;
var viewState = Windows.UI.ViewManagement.ApplicationViewState;
if (layoutState === viewState.snapped) {
that.disposePage();
}
},
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
onBindingComplete: function onBindingComplete() {
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() {
},
/// <summary>
/// call pageRefresh when page refresh button on bottom edgy is clicked
/// </summary>
onRefreshClick: function onRefreshClick(e) {
CommonJS.dismissAllEdgies();
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumRefreshClicked");
Platform.Telemetry.FlightRecorder.logUserAction(Platform.Telemetry.LogLevel.normal, Platform.Telemetry.ActionContext.bottomEdgy, "Refresh", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0);
if (WeatherAppJS.Networking.internetAvailable) {
this.onPageRefresh(true);
}
else {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("NoInternetConnectionError"), false);
}
},
/// <summary>
/// method to call when change-to-Fahrenheit button on bottom edgy is clicked
/// </summary>
onChangeUnitToFClick: function onChangeUnitToFClick(e) {
CommonJS.dismissAllEdgies();
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumBottomEdgyUnitChanged");
WeatherAppJS.SettingsManager.setDisplayUnitAsync('F', Platform.Telemetry.ActionContext.bottomEdgy).then();
},
/// <summary>
/// method to call when change-to-Celsius button on bottom edgy is clicked
/// </summary>
onChangeUnitToCClick: function onChangeUnitToCClick(e) {
CommonJS.dismissAllEdgies();
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumBottomEdgyUnitChanged");
WeatherAppJS.SettingsManager.setDisplayUnitAsync('C', Platform.Telemetry.ActionContext.bottomEdgy).then();
},
/// <summary>
/// method to call when Change Home button on bottom edgy is clicked
/// </summary>
onChangeHomeClick: function onChangeHomeClick(event) {
Platform.Telemetry.FlightRecorder.logUserAction(Platform.Telemetry.LogLevel.normal, Platform.Telemetry.ActionContext.bottomEdgy, "Change Home", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0);
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumChangeHomeClick");
var changeHomeFlyout = document.getElementById("changeHomeFlyout");
var changeHomeContainer = document.createElement("div");
WinJS.Utilities.addClass(changeHomeContainer, "changeHomeContainer");
var flyoutControl = changeHomeFlyout.winControl;
WeatherAppJS.Utilities.UI.dismissPlatformFlyout();
function changeHomeFlyoutClick(locationName) {
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumUseExistingCity");
var eventAttr = { currentHome: WeatherAppJS.SettingsManager.getDefaultLocation().getFullDisplayName(), pickedHome: locationName.getFullDisplayName() };
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, "Change Home Flyout", "Fav/Recent Location", Platform.Telemetry.UserActionOperation.select, Platform.Telemetry.UserActionMethod.unknown, 0, JSON.stringify(eventAttr));
flyoutControl.hide();
CommonJS.dismissAllEdgies();
WeatherAppJS.SettingsManager.setDefaultLocationAsync(locationName, false).then(null,
function (e) {
if (e.errorcode === WeatherAppJS.ErrorCodes.SettingsManager.FAVORITES_MAX_LIMIT_REACHED) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("MaxFavoritesLimitReached"), false);
}
else if (e.errorcode === WeatherAppJS.ErrorCodes.SettingsManager.LOCATION_PINNED_TO_START) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("LocationPinnedToStart"), false);
}
});
}
function addNewLocClick() {
var eventAttr = { currentHome: WeatherAppJS.SettingsManager.getDefaultLocation().getFullDisplayName() };
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, "Change Home Flyout", "Add Location", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0, JSON.stringify(eventAttr));
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumChangeHomeAdd");
flyoutControl.hide();
if (WeatherAppJS.SettingsManager.isFavoritesMaxLimitReached()) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("MaxFavoritesLimitReached"), false);
}
else if (WeatherAppJS.Networking.internetAvailable === false) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("NoInternetConnectionError"), false);
}
else {
WeatherAppJS.Utilities.UI.addNewHomeLoc();
}
}
var currentSelectedIndex = -1;
function changeHomeFlyout_onKeydown(e) {
var Key = WinJS.Utilities.Key;
var isUpKey = false;
switch (e.keyCode) {
case Key.upArrow:
isUpKey = true;
break;
case Key.downArrow:
break;
case Key.enter:
case Key.space:
// Prevent the default behaviour of "Space" and "Enter" keys from scrolling the items
e.preventDefault();
return;
default:
return;
}
e.preventDefault();
e.stopImmediatePropagation();
var itemList = e.currentTarget.querySelectorAll(".changeHomeSectionDiv");
var curIndex = currentSelectedIndex;
// user has used tab and arrow keys interchangeably
if (document.activeElement !== itemList[curIndex]) {
for (var i = 0; i < itemList.length; i++) {
if (document.activeElement === itemList[i]) {
curIndex = i;
break;
}
}
}
if (itemList.length === 0) {
return;
}
if (curIndex === -1) {
if (isUpKey) {
curIndex = itemList.length - 1;
}
else {
curIndex = 0;
}
}
else {
if (isUpKey) {
curIndex -= 1;
if (curIndex < 0) {
curIndex = itemList.length - 1;
}
}
else {
curIndex += 1;
if (curIndex >= itemList.length) {
curIndex = 0;
}
}
}
itemList[curIndex].focus();
currentSelectedIndex = curIndex;
};
function buildChangeHomeFlyout() {
var listLength = 0;
changeHomeFlyout.innerHTML = "";
changeHomeFlyout.onkeydown = changeHomeFlyout_onKeydown;
CommonJS.loadModule({ fragmentPath: "/html/templates.html", templateId: "changeHomeFlyoutTemplate" }, {}).then(
function (template) {
var resourceLoader = PlatformJS.Services.resourceLoader;
var section = template.querySelector(".changeHomeSection");
var sectionDiv = template.querySelector(".changeHomeSectionDiv");
function addToSection(locationObj, parentSection, /*@optional*/isHomeLoc) {
if (!locationObj) {
return;
}
var structure = sectionDiv.cloneNode(true);
structure.onkeyup = WeatherAppJS.Utilities.TabIndexManager.HandleKeyboardInvocation;
var displayName = WeatherAppJS.GeocodeCache.getFullDisplayName(locationObj.getId());
structure.querySelector(".changeHomeSectionText").innerText = displayName;
if (isHomeLoc) {
WinJS.Utilities.addClass(structure.querySelector(".changeHomeSectionIcon"), "changeHomeDefaultLocIcon");
var currentHomeNarratorLabel = resourceLoader.getString("CurrentHomeNarratorString");
structure.querySelector(".changeHomeSectionText").setAttribute("aria-hidden", "true");
structure.setAttribute("aria-label", currentHomeNarratorLabel.format(displayName));
}
(function (loc) {
structure.addEventListener("click",
function (e) {
changeHomeFlyoutClick(loc);
});
})(locationObj);
parentSection.appendChild(structure);
}
WeatherAppJS.SettingsManager.getFavoritesAsync().then(
function (favorites) {
var favSection = section.cloneNode(true);
favSection.querySelector(".changeHomeSectionText").innerText = resourceLoader.getString("Favorites");
addToSection(WeatherAppJS.SettingsManager.getDefaultLocation(), favSection, true);
if (favorites && favorites.length > 0) {
listLength += favorites.length;
for (var i = 0; i < favorites.length; i++) {
addToSection(favorites[i], favSection);
}
}
changeHomeContainer.appendChild(favSection);
});
WeatherAppJS.SettingsManager.getRecentLocationsAsync().then(
function (recentLocs) {
if (recentLocs && recentLocs.length > 0) {
listLength += recentLocs.length;
var recSection = section.cloneNode(true);
recSection.querySelector(".changeHomeSectionText").innerText = resourceLoader.getString("RecentSearches");
for (var i = 0; i < recentLocs.length; i++) {
addToSection(recentLocs[i], recSection);
}
changeHomeContainer.appendChild(recSection);
}
});
var addNewSection = sectionDiv.cloneNode(true);
addNewSection.tabIndex = "0";
addNewSection.setAttribute("role", "button");
addNewSection.onkeyup = WeatherAppJS.Utilities.TabIndexManager.HandleKeyboardInvocation;
addNewSection.querySelector(".changeHomeSectionText").innerText = resourceLoader.getString("AddNewLocationString");
WinJS.Utilities.addClass(addNewSection, "changeHomeAddNew");
addNewSection.addEventListener("click", addNewLocClick);
changeHomeFlyout.appendChild(changeHomeContainer);
changeHomeFlyout.appendChild(addNewSection);
});
return (listLength !== 0);
}
function changeHomeFlyoutCleanup() {
CommonJS.dismissAllEdgies();
changeHomeFlyout.innerHTML = "";
flyoutControl.removeEventListener("afterhide", changeHomeFlyoutCleanup);
}
if (buildChangeHomeFlyout()) {
flyoutControl.addEventListener("afterhide", changeHomeFlyoutCleanup);
var changeHomeButton = document.getElementById('changeHomeButton');
flyoutControl.show(changeHomeButton, "top");
changeHomeFlyout.focus();
}
else {
// No favorites + No recent searches scenario, launch add location flyout based on internet avalability
if (WeatherAppJS.Networking.internetAvailable === false) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("NoInternetConnectionError"), false);
}
else {
WeatherAppJS.Utilities.UI.addNewHomeLoc();
}
}
},
/// <summary>
/// method to call when Current Location button on bottom edgy is clicked
/// </summary>
onCurrentLocationClick: function onCurrentLocationClick(event, currentPageLocation) {
var that = this;
CommonJS.dismissAllEdgies();
WeatherAppJS.Utilities.UI.dismissPlatformFlyout(); // dismiss flyout if already opened by add-location button
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumCurrentLocationBottomEdgyClicked");
if (WeatherAppJS.Networking.internetAvailable) {
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
var detectAndFetchLocationPromise = WeatherAppJS.LocationTracking.detectAndFetchCurrentLocationDataAsync();
that._promisesStack.push(detectAndFetchLocationPromise);
detectAndFetchLocationPromise.then(
function (locationObj) {
var eventAttr = { detectedLocation: locationObj.getFullDisplayName(), accuracy: locationObj.locDetectAccuracy };
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, Platform.Telemetry.ActionContext.bottomEdgy, "Detect Location", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0,JSON.stringify(eventAttr));
if (locationObj.locDetectAccuracy > PlatformJS.Services.appConfig.getInt32("DetectedLocationAccuracyThreshold")) {
WeatherAppJS.Utilities.UI.showAddLocationFlyout(locationObj);
} else {
if (locationObj && locationObj.getId() !== currentPageLocation) {
if (locationObj.getId() === WeatherAppJS.SettingsManager.getDefaultLocationId()) {
PlatformJS.Navigation.navigateToChannel('Home');
}
else {
PlatformJS.Navigation.navigateToChannel('Home', { locID: locationObj.getId(), geocodeLocation: locationObj });
}
}
}
},
function (err) {
WeatherAppJS.Utilities.UI.dismissPlatformFlyout();
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
if (err.errorcode === WeatherAppJS.ErrorCodes.LocationTracking.LOCATION_TRACKING_DISABLED) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("LocationDisabledError"), false);
}
else if (err.errorcode === WeatherAppJS.ErrorCodes.LocationTracking.LOCATION_DETECTION_FAILED) {
WeatherAppJS.Utilities.Instrumentation.incrementInt32("NumCurrentLocationBottomEdgyFailed");
Platform.Telemetry.FlightRecorder.logContentError(Platform.Telemetry.LogLevel.high, "", "Current Location Detection Failed", err.errorcode, "", "");
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("CurrentLocationFetchErrorMsg"), false);
}
else if (err.errorcode === WeatherAppJS.ErrorCodes.LocationTracking.NO_WEATHER_DATA) {
Platform.Telemetry.FlightRecorder.logContentError(Platform.Telemetry.LogLevel.high, "", "No weather data available when location detected", err.errorcode, "", "");
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("CurrentLocDataNotAvailable"), false);
}
});
}
else {
WeatherAppJS.Utilities.UI.dismissPlatformFlyout();
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("NoInternetConnectionError"), false);
}
},
})
});
WinJS.Namespace.define("WeatherAppJS", {
WeatherPanoramaBasePage: WinJS.Class.derive(WeatherAppJS.WeatherBasePage,
function (state) {
WeatherAppJS.WeatherBasePage.call(this, state);
this._panoramaControl = document.getElementById("mainPanorama").winControl;
if (state && state.panoramaState) {
this._panoramaControl.panoramaState = state.panoramaState;
}
var that = this;
that._data = new PlatformJS.Utilities.Binding.List();
that._clusterDefs = {};
}, {
_panoControl: null,
_panoState: null,
_data: null,
/// <summary>
/// Method to invoke to register a callback for when page refresh is called
/// </summary>
onInternetChange: function onInternetChange(functionRef) {
var currentPage = PlatformJS.Navigation.currentIPage;
if (currentPage.onInternetChange && currentPage.onInternetChange instanceof Function) {
currentPage.onInternetChange();
}
},
/// <summary>
/// This function is invoked by the device has been roated
/// </summary>
/// <param name="event">
/// orientation change event
/// </param>
onOrientationChange: function onOrientationChange(event) {
msWriteProfilerMark("WeatherApp:OrientationChange:s");
if (this._panoramaControl && this._panoramaControl.onOrientationChange) {
this._panoramaControl.onOrientationChange(event);
}
msWriteProfilerMark("WeatherApp:OrientationChange:e");
},
/// <summary>
/// This function is invoked when 'make everything on your screen bigger' setting is changed.
/// </summary>
/// <param name="event">
/// dpi change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onDpiChange: function onDpiChange(event) {
var panoControl = this._panoramaControl;
if (panoControl && panoControl.onDpiChange) {
panoControl.onDpiChange(event);
}
},
/// <summary>
/// dispose event handler for the page.
/// panorama event handlers need to be disposed off explicitly.
/// </summary>
dispose: function dispose() {
this._clusterDefs = null;
this._data = null;
if (this._panoramaControl && this._panoramaControl.dispose) {
this._panoramaControl.dispose();
this._panoramaControl = null;
}
if (this.disposePage) {
this.disposePage();
}
},
displayLastUpdatedTime: function displayLastUpdatedTime() {
if (this._lastUpdatedTime && this._panoramaControl) {
var ts = new Date(this._lastUpdatedTime);
var formatTimeStamp = PlatformJS.Services.resourceLoader.getString("LastUpdatedDataTime").format(WeatherAppJS.Utilities.Formatting.getFormattedLastUpdateTime(ts.getFullYear(), ts.getMonth(), ts.getDate(), ts.getHours(), ts.getMinutes(), ts.getSeconds()));
this._panoramaControl.watermark = formatTimeStamp;
}
},
/// <summary>
/// Handle to cluster and module definitions
/// </summary>
_clusterDefs: null,
/// <summary>
/// create a new cluster
/// </summary>
createCluster: function createCluster(clusterKey) {
if (this._clusterDefs) {
if (!this._clusterDefs[clusterKey]) {
this._clusterDefs[clusterKey] = new PlatformJS.Utilities.Binding.List();
}
}
},
/// <summary>
/// method to invoke to add a module definition to a cluster
/// </summary>
addModuleToCluster: function addModuleToCluster(clusterKey, moduleDefinition) {
if (this._clusterDefs) {
if (!this._clusterDefs[clusterKey]) {
this._clusterDefs[clusterKey] = new PlatformJS.Utilities.Binding.List();
}
this._clusterDefs[clusterKey].push(moduleDefinition);
}
},
/// <summary>
/// Add a module to a cluster at Penultimate position 
/// </summary>
addModuleAtPenultimatePosition: function addModuleAtPenultimatePosition(clusterKey, moduleDefinition) {
if (this._clusterDefs) {
if (!this._clusterDefs[clusterKey]) {
this._clusterDefs[clusterKey] = new PlatformJS.Utilities.Binding.List();
}
this._clusterDefs[clusterKey].splice(this._clusterDefs[clusterKey].length - 1, 0, moduleDefinition);
}
},
/// <summary>
/// remove a module from a cluster
/// </summary>
removeModuleFromCluster: function removeModuleFromCluster(clusterKey, moduleIndex) {
if (this._clusterDefs[clusterKey]) {
this._clusterDefs[clusterKey].remove(moduleIndex);
}
// if there are no more modules in cluster, remove the cluster from panorama
if (this._clusterDefs[clusterKey].length === 0) {
this.removeClusterFromPanorama(clusterKey);
}
},
/// <summary>
/// method to invoke to remove a cluster and associated modules from the pano
/// </summary>
removeClusterFromPanorama: function removeClusterFromPanorama(clusterKey) {
if (!this._data) {
return;
}
// Remove all modules from cluster definition
if (this._clusterDefs[clusterKey]) {
while (this._clusterDefs[clusterKey].length > 0) {
this._clusterDefs[clusterKey].pop();
}
delete this._clusterDefs[clusterKey];
}
// Remove cluster from panorama
for (var i = 0; i < this._data.length; i++) {
var element = this._data.getItem(i);
if (element.data.clusterKey === clusterKey) {
this._data.splice(i, 1);
}
}
},
/// <summary>
/// method to remove all clusters from pano. usually called on page dispose.
/// </summary>
resetAllClusters: function resetAllClusters() {
if (this._clusterDefs) {
// Remove all modules from cluster definition
for (var clusterKey in this._clusterDefs) {
if (this._clusterDefs[clusterKey]) {
while (this._clusterDefs[clusterKey].length > 0) {
this._clusterDefs[clusterKey].pop();
}
delete this._clusterDefs[clusterKey];
}
}
}
if (this._data && this._data.length > 0) {
// the best way to clear the panorama of all clusters on one-shot as per platform team's recommendation is to re-set it to a new list; this prevents re-drawing the panorama 
this._data = new PlatformJS.Utilities.Binding.List();
// since we have a new binding list, we also need to set that to the panorama 
// and sort it so that when the clusters get added they are sorted.
this._panoramaControl.clusterDataSource = this._data.createSorted(function (left, right) {
if (left.clusterKey < right.clusterKey) {
return -1;
} else if (left.clusterKey === right.clusterKey) {
return 0;
} else {
return 1;
}
}).dataSource;
}
},
/// <summary>
/// method to pop clusters one by one. This is used in FRE to unload sample data. When in doubt, use removeAllClusters.
/// </summary>
popAllClusters: function popAllClusters() {
if (!this._data) {
return;
}
for (var clusterKey in this._clusterDefs) {
this.removeClusterFromPanorama(clusterKey);
}
while (this._data.length > 0) {
this._data.pop();
}
},
/// <summary>
/// method to add a cluster to the pano control. ClusterType property needs to be passed in the meta data, which in turn is treated as a class and invoked.
/// </summary>
addClusterToPanorama: function addClusterToPanorama(clusterMeta, options) {
if (!clusterMeta) {
return;
}
var cluster = null;
if (clusterMeta.clusterType) {
try {
var ClusterType = clusterMeta.clusterType;
cluster = new ClusterType(clusterMeta, options);
if (cluster) {
this._data.push(cluster);
}
} catch (err) {
// could not create new cluster of given type
// just continue without loading the cluster if some error happens at this stage
}
}
},
/// <summary>
/// accessor for module datasource
/// </summary>
getModulesDatasource: function getModulesDatasource(clusterKey) {
if (this._clusterDefs[clusterKey]) {
return this._clusterDefs[clusterKey].dataSource;
}
return null;
},
/// <summary>
/// method to check if the pano already has the cluster
/// </summary>
containsCluster: function containsCluster(clusterKey) {
if (!this._data) {
return false;
}
for (var i = 0; i < this._data.length; i++) {
var element = this._data.getItem(i);
if (element.data.clusterKey === clusterKey) {
return true;
}
}
return false;
},
/// <summary>
/// get count of all modules in a cluster
/// </summary>
getTotalModulesCount: function getTotalModulesCount(clusterKey) {
if (this._clusterDefs && this._clusterDefs[clusterKey]) {
return this._clusterDefs[clusterKey].length;
}
},
/// <summary>
/// get a module from a cluster
/// </summary>
getModuleFromCluster: function getModuleFromCluster(clusterKey, moduleIndex) {
if (this._clusterDefs && this._clusterDefs[clusterKey]) {
return this._clusterDefs[clusterKey].getItem(moduleIndex);
}
},
/// <summary>
/// get all modules from a cluster
/// </summary>
getAllModulesOfType: function getAllModulesOfType(clusterKey) {
if (this._clusterDefs && this._clusterDefs[clusterKey]) {
return this._clusterDefs[clusterKey];
}
}
})
});