﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function () {
"use strict";
importScripts("//Microsoft.WinJS.1.0/js/base.js");
var notifications = Windows.UI.Notifications;
var resourceFile = WinJS.Resources;
var presetLocations = {
Location1: {
Name: "New York City",
Latitude: "40.714",
Longitude: "-74.007"
},
Location2: {
Name: "London",
Latitude: "51.506",
Longitude: "-0.127"
},
Location3: {
Name: "Paris",
Latitude: "48.857",
Longitude: "2.341"
},
Location4: {
Name: "Mumbai",
Latitude: "18.927",
Longitude: "72.831"
},
Location5: {
Name: "Sydney",
Latitude: "-33.870",
Longitude: "151.207"
}
};
// 
// The background task instance's activation parameters are available via Windows.UI.WebUI.WebUIBackgroundTaskInstance.current
//
var cancel = false,
progress = 0,
taskInstance = Windows.UI.WebUI.WebUIBackgroundTaskInstance.current;
//
// Associate a cancellation handler with the background task.
//
function onCanceled(cancelSender, cancelReason) {
cancel = true;
}
taskInstance.addEventListener("canceled", onCanceled);
function getDefaultDisplayUnit() {
var defaultValue = 'C';
try {
defaultValue = AppEx.WeatherApp.Services.Utilities.isRegionMetric() ? 'C' : 'F';
} catch (err) {
}
return defaultValue;
}
function getNotificationServerUriForLocation(urlTemplate, locationID) {
var locationInfo = presetLocations[locationID];
var serverUri = urlTemplate;
serverUri = serverUri.replace("\{locationName\}", resourceFile.getString("/worldweather/" + locationInfo["Name"]).value);
serverUri = serverUri.replace("\{latitude\}", locationInfo["Latitude"]);
serverUri = serverUri.replace("\{longitude\}", locationInfo["Longitude"]);
return encodeURI(serverUri);
}
//
// This function will setup the app tile with a notification queue to show weather data for top 5 world cities.
//
function presetAppTile() {
if (!cancel) {
msWriteProfilerMark("WeatherApp:FirstSignInTask:s");
try {
//
// Fetch the user's market
//
var middleTierHostTile = "weather.tile.appex.bing.com";
var geographicRegion = new Windows.Globalization.GeographicRegion();
if (geographicRegion.codeTwoLetter === "CN") {
middleTierHostTile = "weather.tile.appex.cn.bing.com";
}
//
// Step1: Initialize
//
var urlTemplate = "http://{middletierhost}/WeatherService.svc/LiveTile?city={locationName}&lat={latitude}&long={longitude}&unit={unit}&lang={lang}&mkt={mkt}&region={region}&appid={appid}&pi=true";
urlTemplate = urlTemplate.replace("\{appid\}", "C98EA5B0842DBB9405BBF071E1DA76512D21FE36");
urlTemplate = urlTemplate.replace("\{mkt\}", "en-US");
urlTemplate = urlTemplate.replace("\{region\}", "US");
urlTemplate = urlTemplate.replace("\{unit\}", getDefaultDisplayUnit());
urlTemplate = urlTemplate.replace("\{lang\}", Platform.Globalization.Marketization.getQualifiedLanguageString());
urlTemplate = urlTemplate.replace("\{middletierhost\}", middleTierHostTile);
//
// Step2: Prepare the URI array for polling.
//
var polledUri;
var urisToPoll = [];
polledUri = getNotificationServerUriForLocation(urlTemplate, "Location5");
urisToPoll.push(new Windows.Foundation.Uri(polledUri));
polledUri = getNotificationServerUriForLocation(urlTemplate, "Location4");
urisToPoll.push(new Windows.Foundation.Uri(polledUri));
polledUri = getNotificationServerUriForLocation(urlTemplate, "Location3");
urisToPoll.push(new Windows.Foundation.Uri(polledUri));
polledUri = getNotificationServerUriForLocation(urlTemplate, "Location2");
urisToPoll.push(new Windows.Foundation.Uri(polledUri));
polledUri = getNotificationServerUriForLocation(urlTemplate, "Location1");
urisToPoll.push(new Windows.Foundation.Uri(polledUri));
// Step3: Setup notification queue.
var recurrence = Windows.UI.Notifications.PeriodicUpdateRecurrence.hour;
var tileUpdater = notifications.TileUpdateManager.createTileUpdaterForApplication();
if (tileUpdater) {
tileUpdater.enableNotificationQueue(true);
tileUpdater.startPeriodicUpdateBatch(urisToPoll, recurrence);
taskInstance.succeeded = true;
taskInstance.progress = 100;
} else {
taskInstance.succeeded = false;
taskInstance.progress = 0;
}
} catch (ex) {
taskInstance.succeeded = false;
taskInstance.progress = 0;
}
close();
msWriteProfilerMark("WeatherApp:FirstSignInTask:e");
} else {
taskInstance.succeeded = false;
close();
}
}
presetAppTile();
})();
