﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function () {
'use strict';
WinJS.Namespace.define("WeatherAppJS", {
ArticleReaderPage: WinJS.Class.derive(DynamicPanoJS.DynamicArticleReaderPage,
function (state) {
DynamicPanoJS.DynamicArticleReaderPage.call(this, state);
},
{
getPageImpressionContext: function getPageImpressionContext() {
if (this.instrumentationEntryPoint === 1) {
return WeatherAppJS.Instrumentation.PageContext.PartnerPano + WeatherAppJS.Instrumentation.PageContext.ArticleReader;
}
return WeatherAppJS.Instrumentation.PageContext.ArticleReader;
},
_handleShareRequestImpl: function _handleShareRequestImpl(request, shareData) {
var that = this;
var stdFormats = Windows.ApplicationModel.DataTransfer.StandardDataFormats;
if (!shareData.pageState || !shareData.articleHeader) {
return null;
}
request.data.properties.title = this.formatShareTitle(shareData);
request.data.properties.description = this.formatShareDescription(shareData);
// Set a delegate to return the html, when the target app requests
request.data.setDataProvider(stdFormats.html, function (formatsRequest) { that.onDeferredDataRequested(formatsRequest, shareData, stdFormats.html); });
request.data.setDataProvider(stdFormats.text, function (formatsRequest) { that.onDeferredDataRequested(formatsRequest, shareData, stdFormats.text); });
request.data.setDataProvider(stdFormats.uri, function (formatsRequest) { that.onDeferredDataRequested(formatsRequest, shareData, stdFormats.uri); });
},
onDeferredDataRequested: function onDeferredDataRequested(request, shareData, format) {
var deferral = request.getDeferral();
var stdFormats = Windows.ApplicationModel.DataTransfer.StandardDataFormats;
try {
if (format === stdFormats.html) {
var htmlText = this.formatShareHTML(shareData);
if (htmlText) {
var htmlFormat = Windows.ApplicationModel.DataTransfer.HtmlFormatHelper.createHtmlFormat(htmlText);
request.setData(htmlFormat);
}
}
else if (format === stdFormats.text) {
var shareText = this.formatShareUri(shareData);
if (shareText) {
request.setData(shareText);
}
}
else if (format === stdFormats.uri) {
var shareUri = this.formatShareUri(shareData);
if (shareUri) {
request.setData(new Windows.Foundation.Uri(shareUri));
}
}
} catch (ex) {
}
deferral.complete();
},
formatShareUri: function formatShareUri(shareData) {
if (shareData.pageState.initialArticleId) {
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
uriBuilder.controllerId = "application";
uriBuilder.commandId = "view";
uriBuilder.queryParameters.insert("entitytype", "article");
var urlParts = shareData.pageState.initialArticleId.split("/");
uriBuilder.queryParameters.insert("pageid", urlParts[0]);
if (urlParts.length === 2) {
uriBuilder.queryParameters.insert("contentid", urlParts[1]);
}
else {
uriBuilder.queryParameters.insert("contentid", "");
}
uriBuilder.queryParameters.insert("market", shareData.pageState.market);
var uriString = uriBuilder.toString();
return uriString;
}
else {
return null;
}
},
formatShareTitle: function formatShareTitle(shareData) {
if (shareData.articleHeader.headline) {
return PlatformJS.Services.resourceLoader.getString("SharePageTitle").format(shareData.articleHeader.headline);
}
else {
return "";
}
},
formatShareDescription: function formatShareDescription(shareData) {
var publisherName = shareData.articleHeader.publisherName || "";
var result = shareData.articleHeader.author ? (shareData.articleHeader.author + " | ") : "";
if (publisherName && result) {
result += publisherName + " | ";
}
if (result) {
result += shareData.articleHeader.date;
}
return result;
},
formatShareHTML: function formatShareHTML(shareData) {
var shareUri = this.formatShareUri(shareData);
if (shareUri) {
var win8ShareText = PlatformJS.Services.resourceLoader.getString("/platform/win8Share");
var win8ShareLinkText = PlatformJS.Services.resourceLoader.getString("/platform/win8ShareLink");
var link = '<a href=\"' + shareUri + '\">' + win8ShareLinkText.format(CommonJS.getAppName()) + '</a>';
var message = win8ShareText.format(PlatformJS.Services.resourceLoader.getString("/platform/win8Brand"), link);
return "<h2><b>" + shareData.articleHeader.headline +
"</b></h2><p>" + shareData.articleHeader.author +
"</p><p>" + shareData.articleHeader.publisherName + " - " + shareData.articleHeader.date +
"</p><blockquote style=\"background-color:#f2efed\">" + shareData.articleHeader.snippet +
"</blockquote><p>" + message + "</p>";
}
else {
return "";
}
}
})
});
})();
