﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function (global) {
'use strict';
WinJS.Namespace.define("WeatherAppJS.Pages", {
Home: WinJS.Class.derive(WeatherAppJS.Core.WeatherPanoramaBasePage,
function Home_ctor(state) {
msWriteProfilerMark("WeatherApp:Home:Load:s");
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
WeatherAppJS.Core.WeatherPanoramaBasePage.call(this, state);
var that = this;
var locID = null;
// if no state is passed or if state.isHome is set to true, it'll be considered homepage
this._isHome = false;
if (!state || (state && state.isHome) || !WeatherAppJS.LocationsManager.getDefaultLocation()) {
this._isHome = true;
} else {
locID = state.locID;
var geoLoc = state.geocodeLocation;
if (!locID) {
this._isHome = true;
} else if (!WeatherAppJS.GeocodeCache.getLocation(locID)) { // Check if lat-long info. available
if (geoLoc && locID === geoLoc.getId()) {
var geocodeLocation = WeatherAppJS.GeocodeLocation.createGeocodeLocation(geoLoc);
WeatherAppJS.GeocodeCache.addLocation(geocodeLocation);
} else {
// Lat-long info not available
this._isHome = true;
}
} else if (locID === WeatherAppJS.SettingsManager.getDefaultLocationId()) {  // For a ski Resort isHome has to be set by doing the check when selected from ECV.
this._isHome = true;
}
}
// hide edgy buttons not necessary for home page
if (this._isHome) {
document.querySelector(".mainActionBarLeft-NotOnHome").style.display = "none";
}
// based on whether this is home or citydetails, set the locID property correctly
if (!this._isHome) {
// saving the location state
this._locID = locID;
this._geoLoc = WeatherAppJS.GeocodeCache.getLocation(locID);
} else {
this._locID = WeatherAppJS.LocationsManager.getDefaultLocation();
}
// coming from a search location page?
if (state && state.searchingLocation === true) {
this._searchingLocation = true;
this._edgyShownAfterNavigation = false;
}
this._bindablePageRefreshFn = this.onPageRefresh.bind(this);
this._bindableNetworkOnlineFn = this.onNetworkOnline.bind(this);
this._bindableAddLocationFlyoutHideFn = this.onAddLocationFlyoutHide.bind(this);
this._bindableDefaultLocationUpdatedFn = this.onDefaultLocationUpdated.bind(this);
this._bindableSamePageNavFn = this.onSamePageNav.bind(this);
this._bindableFirstViewRealizedFn = this.onFirstViewRealized.bind(this);
this._detailsImpl = WeatherAppJS.Pages.DetailsPage.DetailsImplFactory.create(this._locID);
this._state = state || {};
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
msWriteProfilerMark("WeatherApp:Home:Load:e");
WeatherAppJS.Networking.addEventListener('networkonline', this._bindableNetworkOnlineFn, false);
},
{
_locID: null,
_geoLoc: null,
_isHome: true,
_bypassCache: false,
_isPageDestroyed: false,
_detailsImpl: null,
_nextStepsRenderPromise: null,
_gettingStartedRenderPromise: null,
getPageImpressionContext: function getPageImpressionContext() {
var pageContext;
if (this._isHome) {
pageContext = WeatherAppJS.Instrumentation.PageContext.Home;
} else {
pageContext = this._detailsImpl.getPageContext();
}
return pageContext;
},
// IPAGE interface
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() {
var state = {};
if (!this._isHome) {
var locID = this._locID;
var geoLoc = this._geoLoc;
if (!geoLoc) {
geoLoc = WeatherAppJS.GeocodeCache.getLocation(locID);
}
if (locID && geoLoc) {
state = { locID: locID, geocodeLocation: geoLoc };
}
}
var pano = this._panoramaControl;
var panoState = pano ? pano.getPanoramaState() : null;
state.panoramaState = panoState;
return state;
},
getPageData: function getPageData() {
var that = this;
if (that._detailsImpl) {
that._detailsImpl.clearPageClass();
}
that._detailsImpl = WeatherAppJS.Pages.DetailsPage.DetailsImplFactory.create(that._locID);
that._detailsImpl.setTheme();
that._detailsImpl.setPageClass();
that._getDataPromise = that._detailsImpl.getPageData(that);
return that._getDataPromise;
},
onBindingComplete: function onBindingComplete() {
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
WinJS.Resources.processAll();
var p = WeatherAppJS.Services.mainProcessManager.processListener;
var loc = WeatherAppJS.GeocodeCache.getLocation(this._locID);
//Fire a search event for App launch or Pinned Tile click.
if (p._launchMode) {
this._logSearch(Platform.Telemetry.SearchMethod.view, p._launchMode, loc);
p._launchMode = null;
}
if (this._state) {
if (this._state.formCode) {
var method = this._state.method ? this._state.method : Platform.Telemetry.SearchMethod.view;
this._logSearch(method, this._state.formCode, loc);
this._state.formCode = this._state.method = null;
}
if (this._state.isNavBarEvent) {
this._logSearch(Platform.Telemetry.SearchMethod.view, WeatherAppJS.Instrumentation.FormCodes.TopEdgy, loc);
this._state.isNavBarEvent = false;
}
}
// Start listening on the settings change event
WeatherAppJS.SettingsManager.addEventListener('defaultlocationupdated', this._bindableDefaultLocationUpdatedFn, false);
CommonJS.WindowEventManager.getInstance().addEventListener('samePageNav', this._bindableSamePageNavFn, false);
if (this._panoramaControl) {
this._panoramaControl.addEventListener('afterFirstView', this._bindableFirstViewRealizedFn, false);
}
// Start timer for page data refresh
this.cleanPeriodicTimersStack();
var dataRefreshTimerId = setInterval(this._bindablePageRefreshFn, PlatformJS.Services.appConfig.getString("PageRefreshTime"));
this._timersStack.push(dataRefreshTimerId);
WeatherAppJS.Networking.networkChangeCallback = null;
this.initializeEdgyActionHandlers();
// Update bottom edgy buttons
this.updateAllEdgyButtons(this._locID);
//// prefetch world weather data, so that it won't be empty if user visits that page in offline mode.
//WeatherAppJS.DataManager.updateWorldWeatherCache("World", WeatherAppJS.SettingsManager.getDisplayUnit());
},
_logSearch: function _logSearch(method, formCode, loc) {
if (loc) {
Platform.Telemetry.FlightRecorder.logSearch(Platform.Telemetry.LogLevel.normal, loc.getFullDisplayName(), "Bing", method , true, -1, false, true, false, formCode, loc.latitude + ' - ' + loc.longitude);
}
},
onLayoutChange: function onLayoutChange(layoutState) {
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="layoutState">
/// The current layout state
/// </param>
/// <returns>
/// Nothing
/// </returns>
if (this._panoramaControl && this._panoramaControl.onLayoutChange) {
this._panoramaControl.onLayoutChange(layoutState);
}
var that = this;
if (layoutState === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
that.disposePage();
var pano = this._panoramaControl;
var panoState = pano ? pano.getPanoramaState() : null;
if (!this._isHome) {
return {
pageInfo: {
page: "WeatherAppJS.SnapHome",
fragment: "/panoramas/snapmode/snapHome.html"
},
state: {
locID: this._locID,
panoramaState: panoState
}
};
}
} else {
WeatherAppJS.Utilities.UI.adjustHeroClusterForResolution();
}
},
onOrientationChange: function onOrientationChange(event) {
/// <summary>
/// This function is invoked by the device has been rotated
/// </summary>
/// <param name="event">
/// orientation change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
msWriteProfilerMark("WeatherApp:OrientationChange:s");
var uiUtilities = WeatherAppJS.Utilities.UI;
if (this._panoramaControl && this._panoramaControl.onOrientationChange) {
this._panoramaControl.onOrientationChange(event);
}
uiUtilities._isDailyForecastScrolled = false;
msWriteProfilerMark("WeatherApp:OrientationChange:e");
},
onWindowResize: function onWindowResize(event) {
/// <summary>
/// Handles window resize event. Occurs when:
/// - changing resolution in control panel
/// - WINDOWS+ARROW when using multiple monitors
/// </summary>
/// <param name="event">
/// resize event
/// </param>
/// <returns>
/// Nothing
/// </returns>
WeatherAppJS.Utilities.UI.setWindowHeight();
WeatherAppJS.Utilities.UI.adjustHeroClusterForResolution();
if (this._panoramaControl && this._panoramaControl.onWindowResize) {
this._panoramaControl.onWindowResize(event);
}
},
onPageRefresh: function onPageRefresh(bypassCache) {
/// <summary>
/// This function is invoked to refresh the page
/// </summary>
var that = this;
bypassCache = (bypassCache) || false;
that._bypassCache = bypassCache;
if (that._panoramaControl) {
that._panoramaControl.panoramaState = that._panoramaControl.getPanoramaState();
}
// Refresh the page
if (WeatherAppJS.Networking.internetAvailable === true) {
msWriteProfilerMark("WeatherApp:Home:Refresh:s");
CommonJS.Error.removeError();
var clusters = WeatherAppJS.Controls.Utilities.getClusterControlsInsidePagePano();
for (var i in clusters) {
var cluster = clusters[i];
if (cluster.dispose) {
cluster.dispose();
}
}
if (WeatherAppJS.UI.HWChartManager) {
WeatherAppJS.UI.HWChartManager.clearHWCluster();
}
that._isFirstViewRealized = false;
WeatherAppJS.Controls.Utilities.cancelPromise(that._getDataPromise);
that._clusterDefs = [];
that._data = new WinJS.Binding.List();
CommonJS.forceRefresh();
msWriteProfilerMark("WeatherApp:Home:Refresh:e");
}
},
onSettingsChange: function onSettingsChange(e) {
/// <summary>
/// This function is invoked when the app settings are changed
/// </summary>
var that = this;
if (e.detail.setting === "unitChange") {
// Refresh the page
msWriteProfilerMark("WeatherApp:Home:SettingChange:s");
that.onPageRefresh(true);
msWriteProfilerMark("WeatherApp:Home:SettingChange:e");
}
},
onNetworkOnline: function onNetworkOnline() {
var that = this;
that.onPageRefresh(false);
/* Until FRE is complete */
if (WeatherAppJS.SettingsManager.isFRE() || !WeatherAppJS.LocationsManager.getDefaultLocation()) {
that.freScenario();
}
},
/// <summary>
/// Handles the first run magic for the home page
/// FRE flag gets set once user dismisses user Location Access permission dialog. But FRE process continues until the default location is actually choosen.
/// </summary>
freScenario: function freScenario() {
var that = this;
// remove any old message bar.
if (CommonJS._messageBar) {
CommonJS._messageBar.hide();
}
if (WeatherAppJS.Networking.internetAvailable === true) {
/* FRE-Online */
if (WeatherAppJS.SettingsManager.isFRE()) {
var viewManagement = Windows.UI.ViewManagement;
WeatherAppJS.LocationTracking.getCurrentLocationDataAsync().then(function (locationObj) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
if (locationObj.hasOwnProperty("locDetectAccuracy") && locationObj.locDetectAccuracy <= PlatformJS.Services.appConfig.getInt32("DetectedLocationAccuracyThreshold")) {
WeatherAppJS.SettingsManager.setDefaultLocationAsync(locationObj, true).then();
that._logSearch(Platform.Telemetry.SearchMethod.view, WeatherAppJS.Instrumentation.FormCodes.AppLaunch, locationObj);
} else {
WeatherAppJS.Utilities.UI.showAddLocationFlyout(locationObj, true, that._bindableAddLocationFlyoutHideFn);
}
if (viewManagement.ApplicationView.value !== viewManagement.ApplicationViewState.snapped) {
WeatherAppJS.SettingsManager.setIsFREAsync(false).then(); // from next time, it shouldn't go into FRE mode
}
Platform.Telemetry.FlightRecorder.logUserAction(Platform.Telemetry.LogLevel.normal, "Location Access Dialog", "Allow", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0);
}, function (err) {
if (viewManagement.ApplicationView.value !== viewManagement.ApplicationViewState.snapped) {
WeatherAppJS.SettingsManager.setIsFREAsync(false).then(); // from next time, it shouldn't go into FRE mode
if (!WeatherAppJS.Error.isMarketBlockedError(err)) {
if (!(err && err.errorcode === WeatherAppJS.ErrorCodes.LocationTracking.LOCATION_TRACKING_DISABLED)) {
WeatherAppJS.Error.showMessageBar(PlatformJS.Services.resourceLoader.getString("LocationDetectionFailed"), false);
Platform.Telemetry.FlightRecorder.logUserAction(Platform.Telemetry.LogLevel.normal, "Location Access Dialog", "Allow", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0);
} else {
Platform.Telemetry.FlightRecorder.logUserAction(Platform.Telemetry.LogLevel.normal, "Location Access Dialog", "Block", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0);
}
/* Launch add-location flyout for user to add a city of his choice */
WeatherAppJS.Search.showQuickSearchDialog("mainPanorama", WeatherAppJS.Search.Actions.SetDefault, that._bindableAddLocationFlyoutHideFn);
}
}
});
}
else {
/* User has dismissed location access dialog but not yet picked a default location */
WeatherAppJS.Search.showQuickSearchDialog("mainPanorama", WeatherAppJS.Search.Actions.SetDefault, that._bindableAddLocationFlyoutHideFn);
}
}
else {
/* FRE-Offline */
var msg = PlatformJS.Services.resourceLoader.getString("FREOfflineMessage");
var messageBar = new CommonJS.MessageBar(msg, { level: CommonJS.MessageBarLevelError, autoHide: false });
var bLabel = PlatformJS.Services.resourceLoader.getString("CloseButtonLabel");
messageBar.addButton(bLabel, function () { messageBar.hide(); });
messageBar.show();
}
},
onAddLocationFlyoutHide: function onAddLocationFlyoutHide() {
/// <summary>
/// Overrides the dismiss handler for the add location flyout
/// </summary>
var that = this;
WeatherAppJS.Search.onAddLocationFlyoutHide();
// If default location isn't already set
if (!that._isPageDestroyed
&& !WeatherAppJS.LocationsManager.getDefaultLocation()
&& WeatherAppJS.Networking.internetAvailable === true) {
// User chose to not pick any location of his choice, default to preset default
var presetDefaultLocation = WeatherAppJS.Utilities.Common.getPresetDefaultLocation();
WeatherAppJS.SettingsManager.setDefaultLocationAsync(presetDefaultLocation, true);
}
},
onDefaultLocationUpdated: function onDefaultLocationUpdated() {
/// <summary>
/// Handler for default location updated event.
/// </summary>
var that = this;
// Reload "Home" page with new location data on "defaultlocationupdated"
if (that._isHome) {
var p = WinJS.Promise.wrap(true);
if (WeatherAppJS.SettingsManager.isFRE()) {
p = WeatherAppJS.SettingsManager.setIsFREAsync(false);
}
that._locID = WeatherAppJS.LocationsManager.getDefaultLocation();
that._promisesStack.push(p);
p.then(function () {
that.onPageRefresh(false);
});
}
},
onSamePageNav: function onSamePageNav(e) {
/// <summary>
/// Method to handle same page navigation event thrown by navigation.js
/// </summary>
var that = this;
var channelIDInView = PlatformJS.Navigation.mainNavigator.channelIDInView;
if (channelIDInView === "Home" && that._locID !== WeatherAppJS.SettingsManager.getDefaultLocationId()) {
PlatformJS.Navigation.navigateToChannel('Home');
}
},
onFirstViewRealized: function onFirstViewRealized() {
var that = this;
WeatherAppJS.Services.mainProcessManager.processListener.onFirstViewRealized();
WeatherAppJS.SettingsManager.fetchUserDefaultRegionAsync();
if (!that._isFirstViewRealized && that._detailsImpl.firstViewRealized) {
that._detailsImpl.firstViewRealized(this);
}
that._isFirstViewRealized = true;
},
initializeEdgyActionHandlers: function initializeEdgyActionHandlers() {
if (this._isEdgyActionHandlersInitialized) {
return;
}
this._isEdgyActionHandlersInitialized = true;
var bEdgyElement = document.getElementById("homeEdgy");
var bEdgy = bEdgyElement.winControl;
var tEdgy = PlatformJS.Utilities.getControl("platformNavigationBar");
this._helpButton = bEdgyElement.querySelector("#helpButton");
this._refreshButton = bEdgyElement.querySelector("#refreshButton");
this._changeUnitToFButton = bEdgyElement.querySelector("#changeUnitToFButton");
this._changeUnitToCButton = bEdgyElement.querySelector("#changeUnitToCButton");
this._changeHomeButton = bEdgyElement.querySelector("#changeHomeButton");
this._currentLocationButton = bEdgyElement.querySelector("#currentLocationButton");
var that = this;
var resourceLoader = PlatformJS.Services.resourceLoader;
if (this._helpButton && this._helpButton.winControl) {
this._helpButton.winControl.label = CommonJS.resourceLoader.getString("/platform/HelpLabel");
this._helpButton.addEventListener("click",
function (e) {
WeatherAppJS.Utilities.UI.openInAppHelp();
});
}
if (this._refreshButton && this._refreshButton.winControl) {
this._refreshButton.winControl.label = PlatformJS.Services.resourceLoader.getString("RefreshButtonTitle");
this._refreshButton.addEventListener("click",
function (e) {
that.onRefreshClick(e);
});
}
if (this._changeUnitToFButton && this._changeUnitToFButton.winControl) {
this._changeUnitToFButton.winControl.label = resourceLoader.getString("ChangeUnitToFButtonTitle");
this._changeUnitToFButton.addEventListener("click",
function (e) {
that.onChangeUnitToFClick(e);
});
}
if (this._changeUnitToCButton && this._changeUnitToCButton.winControl) {
this._changeUnitToCButton.winControl.label = resourceLoader.getString("ChangeUnitToCButtonTitle");
this._changeUnitToCButton.addEventListener("click",
function (e) {
that.onChangeUnitToCClick(e);
});
}
if (this._changeHomeButton && this._changeHomeButton.winControl) {
this._changeHomeButton.winControl.label = resourceLoader.getString("ChangeHomeButtonTitle");
this._changeHomeButton.addEventListener("click",
function (e) {
that.onChangeHomeClick(e);
});
}
if (this._currentLocationButton && this._currentLocationButton.winControl) {
this._currentLocationButton.winControl.label = resourceLoader.getString("CurrentLocationButtonTitle");
this._currentLocationButton.addEventListener("click",
function (e) {
that.onCurrentLocationClick(e, that._locID);
});
}
// add buttons and event listeners to the bottom edgy based on whether this is 'home' or just a city details page
if (this._isHome) {
if (bEdgy) {
bEdgy.addEventListener("beforeshow",
function (e) {
that.onBeforeShowBottomEdgy(e);
});
}
} else {
var addButton = bEdgyElement.querySelector("#addFavoriteButton");
var removeButton = bEdgyElement.querySelector("#removeFavoriteButton");
var setDefaultButton = bEdgyElement.querySelector("#setDefaultButton");
var pinButton = bEdgyElement.querySelector("#pinButton");
var unpinButton = bEdgyElement.querySelector("#unpinButton");
if (bEdgy) {
bEdgy.addEventListener("beforeshow",
function (e) {
that.updateEdgyButtons(that._locID);
});
bEdgy.addEventListener("aftershow",
function (e) {
that.updateEdgyPinButtons(that._locID); // this blocks appbar from showing up, so moving this to 'aftershow'
});
}
if (addButton && addButton.winControl) {
addButton.winControl.label = resourceLoader.getString("AddButtonTitle");
addButton.addEventListener("click",
function (e) {
msWriteProfilerMark("WeatherApp:HomePageEdgy:AddFavorite:s");
WeatherAppJS.Utilities.Instrumentation.incrementInt32("HomePageBottomEdgyAddFavorite");
CommonJS.dismissAllEdgies();
// Check cache and get the LatLong details                            
var locationDetails = WeatherAppJS.GeocodeCache.getLocation(that._locID);
var eventAttr = { location: locationDetails.getFullDisplayName() };
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, Platform.Telemetry.ActionContext.bottomEdgy, "Add Location", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0, JSON.stringify(eventAttr));
WeatherAppJS.SettingsManager.addFavoriteAsync(locationDetails).then(
function () {
that.updateAllEdgyButtons(that._locID);
msWriteProfilerMark("WeatherApp:HomePageEdgy:AddFavorite:e");
},
function (e) {
if (e.errorcode === WeatherAppJS.ErrorCodes.SettingsManager.FAVORITES_MAX_LIMIT_REACHED) {
WeatherAppJS.Error.showMessageBar(resourceLoader.getString("MaxFavoritesLimitReached"), false);
}
that.updateAllEdgyButtons(that._locID);
msWriteProfilerMark("WeatherApp:HomePageEdgy:AddFavorite:e");
});
});
}
if (removeButton && removeButton.winControl) {
removeButton.winControl.label = resourceLoader.getString("RemoveButtonTitle");
removeButton.addEventListener("click",
function (e) {
msWriteProfilerMark("WeatherApp:HomePageEdgy:RemoveFavorite:s");
WeatherAppJS.Utilities.Instrumentation.incrementInt32("HomePageBottomEdgyRemoveFavorite");
CommonJS.dismissAllEdgies();
var locationDetails = WeatherAppJS.GeocodeCache.getLocation(that._locID);
var eventAttr = { location: locationDetails.getFullDisplayName() };
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, Platform.Telemetry.ActionContext.bottomEdgy, "Remove", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0, JSON.stringify(eventAttr));
WeatherAppJS.SettingsManager.removeFavoriteAsync(locationDetails).then(
function () {
that.updateAllEdgyButtons(that._locID);
msWriteProfilerMark("WeatherApp:HomePageEdgy:RemoveFavorite:e");
PlatformJS.Navigation.navigateToChannel('MyPlaces');
},
function (e) {
that.updateAllEdgyButtons(that._locID);
msWriteProfilerMark("WeatherApp:HomePageEdgy:RemoveFavorite:e");
});
});
}
if (setDefaultButton && setDefaultButton.winControl) {
setDefaultButton.winControl.label = resourceLoader.getString("SetDefaultButtonTitle");
setDefaultButton.addEventListener("click",
function (e) {
msWriteProfilerMark("WeatherApp:HomePageEdgy:SetDefault:s");
WeatherAppJS.Utilities.Instrumentation.incrementInt32("HomePageBottomEdgySetDefault");
var newDefault = that._locID;
CommonJS.dismissAllEdgies();
var locationDetails = WeatherAppJS.GeocodeCache.getLocation(that._locID); /// Check cache and get the LatLong details
var eventAttr = { location: locationDetails.getFullDisplayName() };
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, Platform.Telemetry.ActionContext.bottomEdgy, "Set as Home", Platform.Telemetry.UserActionOperation.click, Platform.Telemetry.UserActionMethod.unknown, 0, JSON.stringify(eventAttr));
WeatherAppJS.SettingsManager.setDefaultLocationAsync(locationDetails).then(
function () {
// When current city details page location is "Set as Home", make this page behave as "Home"
that._isHome = true;
that.updateAllEdgyButtons(that._locID);
msWriteProfilerMark("WeatherApp:HomePageEdgy:SetDefault:e");
PlatformJS.Navigation.mainNavigator.channelIDInView = "Home";
},
function (e) {
if (e.errorcode === WeatherAppJS.ErrorCodes.SettingsManager.FAVORITES_MAX_LIMIT_REACHED) {
WeatherAppJS.Error.showMessageBar(resourceLoader.getString("SetDefaultMaxLimitReached"), false);
} else if (e.errorcode === WeatherAppJS.ErrorCodes.SettingsManager.LOCATION_PINNED_TO_START) {
WeatherAppJS.Error.showMessageBar(resourceLoader.getString("LocationPinnedToStart"), false);
}
that.updateAllEdgyButtons(that._locID);
msWriteProfilerMark("WeatherApp:HomePageEdgy:SetDefault:e");
});
});
}
if (pinButton && pinButton.winControl) {
pinButton.winControl.label = resourceLoader.getString("/platform/pinToStart");
pinButton.addEventListener("click",
function (e) {
msWriteProfilerMark("WeatherApp:HomePageEdgy:Pin");
var toggleStickyEdgy = WeatherAppJS.Utilities.UI.toggleStickyEdgy;
toggleStickyEdgy(bEdgy, true);
toggleStickyEdgy(tEdgy, true);
WeatherAppJS.App.pinLocationAsync(pinButton, that._locID).then(
function () {
toggleStickyEdgy(bEdgy, false);
toggleStickyEdgy(tEdgy, false);
that.updateEdgyPinButtons(that._locID);
},
function (e) {
toggleStickyEdgy(bEdgy, false);
toggleStickyEdgy(tEdgy, false);
if (e.errorcode && e.errorcode === WeatherAppJS.ErrorCodes.SettingsManager.PINNED_MAX_LIMIT_REACHED) {
WeatherAppJS.Error.showMessageBar(resourceLoader.getString("MaxPinnedLocationsLimitReached"), false);
}
});
});
}
if (unpinButton && unpinButton.winControl) {
unpinButton.winControl.label = resourceLoader.getString("/platform/unpinFromStart");
unpinButton.addEventListener("click",
function (e) {
msWriteProfilerMark("WeatherApp:HomePageEdgy:Unpin");
var toggleStickyEdgy = WeatherAppJS.Utilities.UI.toggleStickyEdgy;
toggleStickyEdgy(bEdgy, true);
toggleStickyEdgy(tEdgy, true);
WeatherAppJS.App.unpinLocationAsync(unpinButton, that._locID).then(
function () {
toggleStickyEdgy(bEdgy, false);
toggleStickyEdgy(tEdgy, false);
that.updateEdgyPinButtons(that._locID);
});
});
}
}
},
onBeforeShowBottomEdgy: function onBeforeShowBottomEdgy(e) {
var useTianQi = Platform.Utilities.Globalization.isFeatureEnabled("UseTianQi");
if (!useTianQi) {
var isCurrentUnitF = (WeatherAppJS.SettingsManager.getDisplayUnit() === "F");
this.toggleShowButton(this._changeUnitToFButton, !isCurrentUnitF);
this.toggleShowButton(this._changeUnitToCButton, isCurrentUnitF);
}
var defaultLoc = WeatherAppJS.LocationsManager.getDefaultLocation();
this.toggleShowButton(this._refreshButton, defaultLoc ? true : false);
this.toggleShowButton(this._changeHomeButton, defaultLoc ? true : false);
var isCurrentLocationDetection = Platform.Utilities.Globalization.isFeatureEnabled("CurrentLocationDetection");
this.toggleShowButton(this._currentLocationButton, (isCurrentLocationDetection && defaultLoc) ? true : false);
},
toggleShowButton: function toggleShowButton(b, show) {
if (b) {
if (show) {
b.style.display = "";
} else {
b.style.display = "none";
}
}
},
updateEdgyButtons: function updateEdgyButtons(locID) {
var addButton = document.getElementById("addFavoriteButton");
var removeButton = document.getElementById("removeFavoriteButton");
var setDefaultButton = document.getElementById("setDefaultButton");
var pinButton = document.getElementById("pinButton");
var unpinButton = document.getElementById("unpinButton");
var changeUnitToFButton = document.getElementById("changeUnitToFButton");
var changeUnitToCButton = document.getElementById("changeUnitToCButton");
var changeHomeButton = document.getElementById("changeHomeButton");
// Check if default location
var defaultLoc = WeatherAppJS.SettingsManager.getDefaultLocationId();
if (defaultLoc !== locID) {
this.toggleShowButton(changeHomeButton, false);
this.toggleShowButton(setDefaultButton, true);
if (WeatherAppJS.SettingsManager.isFavorite(locID)) {
// Is a favorite
this.toggleShowButton(removeButton, true);
this.toggleShowButton(addButton, false);
} else {
this.toggleShowButton(removeButton, false);
this.toggleShowButton(addButton, true);
}
} else {
this.toggleShowButton(pinButton, false);
this.toggleShowButton(unpinButton, false);
this.toggleShowButton(addButton, false);
this.toggleShowButton(removeButton, false);
this.toggleShowButton(changeHomeButton, true);
this.toggleShowButton(setDefaultButton, false);
}
var useTianQi = Platform.Utilities.Globalization.isFeatureEnabled("UseTianQi");
if (!useTianQi) {
var isCurrentUnitF = (WeatherAppJS.SettingsManager.getDisplayUnit() === "F");
this.toggleShowButton(changeUnitToFButton, !isCurrentUnitF);
this.toggleShowButton(changeUnitToCButton, isCurrentUnitF);
}
var isCurrentLocationDetection = Platform.Utilities.Globalization.isFeatureEnabled("CurrentLocationDetection");
this.toggleShowButton(this._currentLocationButton, (isCurrentLocationDetection && defaultLoc) ? true : false);
},
updateEdgyPinButtons: function updateEdgyPinButtons(locID) {
var defaultLoc = WeatherAppJS.SettingsManager.getDefaultLocationId();
if (defaultLoc !== locID) {
var isLocationPinned = WeatherAppJS.App.isLocationPinned(locID);
var pinButton = document.getElementById("pinButton");
var unpinButton = document.getElementById("unpinButton");
if (pinButton && unpinButton) {
this.toggleShowButton(pinButton, !isLocationPinned);
this.toggleShowButton(unpinButton, isLocationPinned);
}
}
},
updateAllEdgyButtons: function updateAllEdgyButtons(locID) {
this.updateEdgyButtons(locID); // updates all buttons on the edgy except the 'pin' buttons
this.updateEdgyPinButtons(locID); // updates only the pin button status based on whether current location is pinned or not
},
_disposePage: function _disposePage() {
/// <summary>
/// Clean up function for the page.
/// </summary>
// Remove event listeners
WeatherAppJS.Networking.removeEventListener('networkonline', this._bindableNetworkOnlineFn);
WeatherAppJS.SettingsManager.removeEventListener('defaultlocationupdated', this._bindableDefaultLocationUpdatedFn);
CommonJS.WindowEventManager.getInstance().removeEventListener('samePageNav', this._bindableSamePageNavFn);
if (this._panoramaControl) {
this._panoramaControl.removeEventListener('afterFirstView', this._bindableFirstViewRealizedFn);
}
// reset the network change call back fucntion.
WeatherAppJS.Networking.networkChangeCallback = null;
this._data = null;
if (WeatherAppJS.UI.HWChartManager) {
WeatherAppJS.UI.HWChartManager.clearHWCluster();
}
this._isPageDestroyed = true;
if (WeatherAppJS.Utilities.UI.MapsFlyout) {
WeatherAppJS.Utilities.UI.MapsFlyout.resetFlyout();
}
clearTimeout(WeatherAppJS.Utilities.UI._hourlyScrollDetectTimer);
if (this._nextStepsRenderPromise) {
this._nextStepsRenderPromise.cancel();
this._nextStepsRenderPromise = null;
}
if (this._gettingStartedRenderPromise) {
this._gettingStartedRenderPromise.cancel();
this._gettingStartedRenderPromise = null;
}
},
setAds: function setAds() {
var that = this;
var locationData = WeatherAppJS.GeocodeCache.getLocation(that._locID);
var locTagsArray = [{ key: "latitude", value: locationData.latitude }, { key: "longitude", value: locationData.longitude }];
PlatformJS.Ads.addOrderedAdsClusterConfig(that._data, {
otherAdOptions: {
adTags: locTagsArray
}
});
},
addGetStartedCluster: function addGetStartedCluster() {
if (this._isHome && Platform.Globalization.Marketization.isCurrentLanguageLocationValid()) {
var gsClusterConfig = WeatherAppJS.Storage.Memory.getItem("gsClusterConfig");
if (!gsClusterConfig) {
gsClusterConfig = {
clusterPosition: 1,
templateName: "gsTemplate",
clusterKey: "getStarted",
useLocalCache: true
};
}
this._gettingStartedRenderPromise = CommonJS.TempCluster.insertClusterIfAllowed(this._data, gsClusterConfig).done(function () {
WeatherAppJS.Storage.Memory.cacheItem("gsClusterConfig", gsClusterConfig);
});
}
},
addNextStepsCluster: function addNextStepsCluster() {
var that = this;
if (Platform.Globalization.Marketization.isCurrentLanguageLocationValid()) {
var nsClusterConfig = WeatherAppJS.Storage.Memory.getItem("nsClusterConfig");
if (!nsClusterConfig) {
nsClusterConfig = {
clusterPosition: 20,
templateName: "nsTemplate",
clusterKey: "nextSteps"
};
}
this._nextStepsRenderPromise = CommonJS.TempCluster.insertNextStepsCluster(this._data, nsClusterConfig).done(function () {
WeatherAppJS.Storage.Memory.cacheItem("nsClusterConfig", nsClusterConfig);
if (that._panoramaControl) {
that._panoramaControl.compactPanorama = true;
}
});
}
}
})
});
WinJS.Namespace.define("WeatherAppJS.Pages.DetailsPage.DetailsImplFactory", {
create: function create(locID) {
var geoLoc = WeatherAppJS.GeocodeCache.getLocation(locID);
var useTianQi = Platform.Utilities.Globalization.isFeatureEnabled("UseTianQi");
if (useTianQi && (!geoLoc || (geoLoc && geoLoc.isTianQiSupportedLocation()))) {
return WeatherAppJS.Pages.DetailsPage.TianQiImpl;
}
if (geoLoc && geoLoc.locType === WeatherAppJS.GeocodeLocation.locationType.cityLocation) {
return WeatherAppJS.Pages.DetailsPage.CityImpl;
} else if (geoLoc && geoLoc.isSkiLocation) {
return WeatherAppJS.Pages.DetailsPage.SkiImpl;
} else {
return WeatherAppJS.Pages.DetailsPage.CityImpl;
}
}
});
WinJS.Namespace.define("WeatherAppJS.Pages.DetailsPage.CityImpl", {
_isClustersPushed: false,
_isAdsPushed: false,
getPageContext: function getPageContext() {
return WeatherAppJS.Instrumentation.PageContext.CityDetails;
},
setTheme: function setTheme(page) {
CommonJS.setTheme(null, true); // set dark theme to platform's assets. This doesn't change per skycode so setting it here.
},
setPageClass: function setPageClass() {
var pageContainer = document.getElementById("mainContainer");
if (pageContainer) {
WinJS.Utilities.addClass(pageContainer, "home");
}
},
clearPageClass: function clearPageClass() {
var pageContainer = document.getElementById("mainContainer");
if (pageContainer) {
WinJS.Utilities.removeClass(pageContainer, "home");
}
},
getPageData: function getPageData(page) {
var that = page;
var pageTitle;
var dataQuery;
var bypassCache = (that._bypassCache) || false;
WeatherAppJS.Pages.DetailsPage.CityImpl._isClustersPushed = false;
WeatherAppJS.Pages.DetailsPage.CityImpl._isAdsPushed = false;
var defaultLocation = WeatherAppJS.LocationsManager.getDefaultLocation();
var isFre = (WeatherAppJS.SettingsManager.isFRE() || !defaultLocation);
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
if (isFre) {
// Disable the top navigation bar until FRE is complete
WeatherAppJS.Utilities.UI.disableNavigationBar();
that.freScenario();
var presetDefaultLocation = WeatherAppJS.Utilities.Common.getPresetDefaultLocation();
that._locID = presetDefaultLocation.getId();
var locationDisplayName = presetDefaultLocation.getShortDisplayName(that._locID);
pageTitle = PlatformJS.Services.resourceLoader.getString("SampleDataHeader").format(locationDisplayName);
} else {
// Show top navigation bar which would have been hidden in FRE. 
// This is to ensure when we always show top navs once FRE is done, and no case slips through.
WeatherAppJS.Utilities.UI.enableNavigationBar();
WeatherAppJS.Utilities.UI.enableBottomEdgy("homeEdgy");
pageTitle = WeatherAppJS.GeocodeCache.getShortDisplayName(that._locID);
}
var pageData = {
title: pageTitle,
panoramaState: {},
showInertiaBackground: true,
semanticZoomRenderer: WeatherAppJS.Utilities.Templates.getSemanticZoomTemplate
};
that._clusterDefs = [];
var p = WinJS.Promise.wrap(true);
dataQuery = WeatherAppJS.LocationsManager.getCCDataForLocationAsync;
if (isFre) {
p = WeatherAppJS.SettingsManager.preFREUserDefaultRegionFetchTimeoutAsync();
};
return new WinJS.Promise(function (complete, error, progress) {
p.then(function () {
return dataQuery(that._locID, false, isFre);
}).then(function (locObj) {
that._lastUpdatedTime = locObj.getCurrentConditions().lastUpdatedTime;
that.displayLastUpdatedTime();
if (!WeatherAppJS.Pages.DetailsPage.CityImpl._isClustersPushed) {
WeatherAppJS.Pages.DetailsPage.CityImpl._pushClusters(that, locObj, bypassCache, isFre);
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
that._data = new WinJS.Binding.List(that._clusterDefs);
WeatherAppJS.Pages.DetailsPage.CityImpl.addAdsIfInMemory(page);
that.addGetStartedCluster();
that.addNextStepsCluster();
pageData.clusterDataSource = that._data.dataSource;
complete(pageData);
}
}, function (e) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
if (PlatformJS.Utilities.isPromiseCanceled(e)) {
return WinJS.Promise.wrapError(e);
}
// show full screen error...
var errorType = (WeatherAppJS.Networking.internetAvailable === true) ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
CommonJS.Error.showError(errorType, function () {
that.onPageRefresh(that._bypassCache);
});
}, function (locObj) {
that._lastUpdatedTime = locObj.getCurrentConditions().lastUpdatedTime;
that.displayLastUpdatedTime();
WeatherAppJS.Pages.DetailsPage.CityImpl._pushClusters(that, locObj, bypassCache, isFre);
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
that._data = new WinJS.Binding.List(that._clusterDefs);
WeatherAppJS.Pages.DetailsPage.CityImpl.addAdsIfInMemory(page);
that.addGetStartedCluster();
that.addNextStepsCluster();
pageData.clusterDataSource = that._data.dataSource;
complete(pageData);
});
}, function () {
WeatherAppJS.Controls.Utilities.cancelPromise(p);
});
},
firstViewRealized: function firstViewRealized(page) {
// Add the ads cluster
this.addAds(page);
// prefetch daily drilldown
var isDailyDrilldownEnabled = WeatherAppJS.Utilities.UI.isDailyDrilldownEnabled(page._locID);
if (isDailyDrilldownEnabled) {
WeatherAppJS.DataManager.prefetchHourlyForecastDataByLatLong(page._locID);
}
},
addAdsIfInMemory: function addAdsIfInMemory(page) {
var homeAdsConfig = WeatherAppJS.Storage.Memory.getItem("homeAdsConfig");
if (homeAdsConfig) {
WeatherAppJS.Pages.DetailsPage.CityImpl.addAds(page);
}
},
addAds: function addAds(page) {
var that = page;
if (WeatherAppJS.Pages.DetailsPage.CityImpl._isAdsPushed) {
return;
}
var defaultLocation = WeatherAppJS.LocationsManager.getDefaultLocation();
if (defaultLocation) { // for FRE, this will be null
// for home/citydetails page, fetch ads config from today.js and set it before adding ads to page
var homeAdsConfig = WeatherAppJS.Storage.Memory.getItem("homeAdsConfig");
var getAdsPromise;
if (homeAdsConfig) {
getAdsPromise = WinJS.Promise.wrap(homeAdsConfig);
} else {
getAdsPromise = WeatherAppJS.DataManager.getAdsAsync(that._bypassCache);
}
that._promisesStack.push(getAdsPromise);
getAdsPromise.then(function (adsConfig) {
// when onNavigateAway is called this promise is not yet added to the stack
if (!that._isPageDestroyed) {
WeatherAppJS.Storage.Memory.cacheItem("homeAdsConfig", adsConfig);
PlatformJS.Ads.setAdConfig(adsConfig);
that.setAds();
WeatherAppJS.Pages.DetailsPage.CityImpl._isAdsPushed = true;
}
}, function (err) {
});
}
},
_pushClusters: function _pushClusters(page, locObj, bypassCache, isFre) {
var that = page;
var singleProviderOnly = PlatformJS.Services.appConfig.getBool("SingleProviderOnly");
var useTianQi = Platform.Utilities.Globalization.isFeatureEnabled("UseTianQi");
var showLimitedExperience = WeatherAppJS.Utilities.UI.showLimitedExperience(that._locID);
WeatherAppJS.Pages.DetailsPage.CityImpl._isClustersPushed = true;
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.heroOverview(that._locID, bypassCache, isFre, false /*useTianQi*/));
var isHourlyClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("HourlyCluster");
// for few countries, we disable features for locations within that same country
// but enable for locations outside that country.
if (!isHourlyClusterEnabled && singleProviderOnly && !showLimitedExperience) {
isHourlyClusterEnabled = true;
}
if (isHourlyClusterEnabled && locObj.getCurrentConditions().isHourlyForecastAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.hourlyForecast(that._locID, bypassCache, isFre));
}
var isInteractiveMapsEnabled = Platform.Utilities.Globalization.isFeatureEnabled("ShowInteractiveMaps");
var isMapsClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("MapsCluster");
if (isMapsClusterEnabled && isInteractiveMapsEnabled) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.interactiveMapsControl(that._locID, bypassCache, isFre));
} else {
// for few countries, we disable features for locations within that same country
// but enable for locations outside that country.
if (!isMapsClusterEnabled && singleProviderOnly && !showLimitedExperience) {
isMapsClusterEnabled = true;
}
if (isMapsClusterEnabled && locObj.getCurrentConditions().isMapsAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.maps(that._locID, bypassCache, isFre));
}
}
if (locObj.getCurrentConditions().isTripPlanAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.historical(that._locID, bypassCache, isFre));
}
if (!isFre && !useTianQi) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.nearbySkiResorts(that._locID, bypassCache));
}
},
});
WinJS.Namespace.define("WeatherAppJS.Pages.DetailsPage.SkiImpl", {
_isClustersPushed: false,
_isAdsPushed: false,
getPageContext: function getPageContext() {
return WeatherAppJS.Instrumentation.PageContext.SkiResorts;
},
setTheme: function setTheme(page) {
CommonJS.setTheme(null, true); // set dark theme to platform's assets. This doesn't change per skycode so setting it here.
},
setPageClass: function setPageClass() {
var pageContainer = document.getElementById("mainContainer");
if (pageContainer) {
WinJS.Utilities.addClass(pageContainer, "skidetails");
}
},
clearPageClass: function clearPageClass() {
var pageContainer = document.getElementById("mainContainer");
if (pageContainer) {
WinJS.Utilities.removeClass(pageContainer, "skidetails");
}
},
getPageData: function getPageData(page) {
var that = page;
var pageTitle = "";
var dataQuery;
var bypassCache = (that._bypassCache) || false;
WeatherAppJS.Pages.DetailsPage.SkiImpl._isClustersPushed = false;
WeatherAppJS.Pages.DetailsPage.SkiImpl._isAdsPushed = false;
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
WeatherAppJS.Utilities.UI.enableNavigationBar();
WeatherAppJS.Utilities.UI.enableBottomEdgy("homeEdgy");
pageTitle = WeatherAppJS.GeocodeCache.getShortDisplayName(that._locID);
var pageData = {
title: pageTitle,
panoramaState: {},
showInertiaBackground: true,
semanticZoomRenderer: WeatherAppJS.Utilities.Templates.getSemanticZoomTemplate
};
that._clusterDefs = [];
var addAds = this.addAds;
var skiDataPromise = WeatherAppJS.LocationsManager.getSkiDetailsAsync(that._locID, false);
return new WinJS.Promise(function (complete, error) {
skiDataPromise.then(function (data) {
var locObj = data;
that._lastUpdatedTime = locObj.getCurrentConditions().lastUpdatedTime;
that.displayLastUpdatedTime();
if (!WeatherAppJS.Pages.DetailsPage.SkiImpl._isClustersPushed) {
WeatherAppJS.Pages.DetailsPage.SkiImpl._pushClusters(page, locObj, bypassCache);
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
that._data = new WinJS.Binding.List(that._clusterDefs);
WeatherAppJS.Pages.DetailsPage.SkiImpl.addAdsIfInMemory(page);
that.addGetStartedCluster();
that.addNextStepsCluster();
pageData.clusterDataSource = that._data.dataSource;
complete(pageData);
}
}, function (err) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
if (PlatformJS.Utilities.isPromiseCanceled(err)) {
return WinJS.Promise.wrapError(err);
}
// show full screen error...
var errorType = (WeatherAppJS.Networking.internetAvailable === true) ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
CommonJS.Error.showError(errorType, function () {
that.onPageRefresh(that._bypassCache);
});
}, function (data) {
var locObj = data;
that._lastUpdatedTime = locObj.getCurrentConditions().lastUpdatedTime;
that.displayLastUpdatedTime();
WeatherAppJS.Pages.DetailsPage.SkiImpl._pushClusters(page, locObj, bypassCache);
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
that._data = new WinJS.Binding.List(that._clusterDefs);
WeatherAppJS.Pages.DetailsPage.SkiImpl.addAdsIfInMemory(page);
that.addGetStartedCluster();
that.addNextStepsCluster();
pageData.clusterDataSource = that._data.dataSource;
complete(pageData);
});
}, function () {
if (skiDataPromise && skiDataPromise.cancel) { skiDataPromise.cancel(); }
});
},
firstViewRealized: function firstViewRealized(page) {
// Add the ads cluster for ski
this.addAds(page);
// prefetch daily drilldown
var isDailyDrilldownEnabled = WeatherAppJS.Utilities.UI.isDailyDrilldownEnabled(page._locID);
if (isDailyDrilldownEnabled) {
WeatherAppJS.DataManager.prefetchHourlyForecastDataByLatLong(page._locID);
}
},
addAdsIfInMemory: function addAdsIfInMemory(page) {
var that = page;
var homeAdsConfig = WeatherAppJS.Storage.Memory.getItem("homeAdsConfig");
if (!that._isHome || homeAdsConfig) {
WeatherAppJS.Pages.DetailsPage.SkiImpl.addAds(page);
}
},
addAds: function addAds(page) {
var that = page;
if (WeatherAppJS.Pages.DetailsPage.SkiImpl._isAdsPushed) {
return;
}
if (that._isHome) {
// if ski place is set as home, fetch today.js
var homeAdsConfig = WeatherAppJS.Storage.Memory.getItem("homeAdsConfig");
var getAdsPromise;
if (homeAdsConfig) {
getAdsPromise = WinJS.Promise.wrap(homeAdsConfig);
} else {
getAdsPromise = WeatherAppJS.DataManager.getAdsAsync(that._bypassCache);
}
that._promisesStack.push(getAdsPromise);
getAdsPromise.then(function (adsConfig) {
WeatherAppJS.Storage.Memory.cacheItem("homeAdsConfig", adsConfig);
PlatformJS.Ads.setAdConfig(adsConfig);
that.setAds();
WeatherAppJS.Pages.DetailsPage.SkiImpl._isAdsPushed = true;
}, function (err) {
});
} else {
that.setAds();
WeatherAppJS.Pages.DetailsPage.SkiImpl._isAdsPushed = true;
}
},
_pushClusters: function _pushClusters(page, locObj, bypassCache) {
var that = page;
var singleProviderOnly = PlatformJS.Services.appConfig.getBool("SingleProviderOnly");
var showLimitedExperience = WeatherAppJS.Utilities.UI.showLimitedExperience(that._locID);
WeatherAppJS.Pages.DetailsPage.SkiImpl._isClustersPushed = true;
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.skiResortsHero(that._locID, bypassCache));
var skiOverview = locObj.getSkiOverview();
if (skiOverview) {
// Push Overview cluster
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.skiOverview(that._locID, false /* bypassCache */));
}
var isHourlyClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("HourlyCluster");
// for few countries, we disable features for locations within that same country
// but enable for locations outside that country.
if (!isHourlyClusterEnabled && singleProviderOnly && !showLimitedExperience) {
isHourlyClusterEnabled = true;
}
if (isHourlyClusterEnabled && locObj.getCurrentConditions().isHourlyForecastAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.skiHourlyForecast(that._locID, bypassCache));
}
var isMapsClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("MapsCluster");
var isInteractiveMapsEnabled = Platform.Utilities.Globalization.isFeatureEnabled("ShowInteractiveMaps");
if (isMapsClusterEnabled && isInteractiveMapsEnabled) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.interactiveMapsControl(that._locID, bypassCache, false));
} else {
// for few countries, we disable features for locations within that same country
// but enable for locations outside that country.
if (!isMapsClusterEnabled && singleProviderOnly && !showLimitedExperience) {
isMapsClusterEnabled = true;
}
if (isMapsClusterEnabled && locObj.getCurrentConditions().isMapsAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.maps(that._locID, bypassCache));
}
}
if (skiOverview) {
if (skiOverview.isCamsAndPanosAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.skiWebcam(that._locID, false /* bypassCache */));
}
if (skiOverview.isDealsAndNewsAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.skiDeals(that._locID, false /* bypassCache */));
}
if (skiOverview.isReviewsAvailable) {
var skiReviewLocObj = locObj.getSkiReviews();
var skiReviewConfig = WeatherAppJS.Configs.Cluster.skiReviews(that._locID, false);
if (skiReviewLocObj.reviewUrl && skiReviewLocObj.reviewUrl.length > 0) {
skiReviewConfig.onHeaderSelection = skiReviewLocObj.reviewUrl[0].reviewUrlClick;
}
that.pushIntoClusterDefs(skiReviewConfig);
}
}
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.skiNearbySkiResorts(that._locID, bypassCache));
}
});
WinJS.Namespace.define("WeatherAppJS.Pages.DetailsPage.TianQiImpl", {
getPageContext: function getPageContext() {
return "/TianQi";
},
setTheme: function setTheme(page) {
CommonJS.setTheme(null, true); // set dark theme to platform's assets. This doesn't change per skycode so setting it here.
},
setPageClass: function setPageClass() {
var pageContainer = document.getElementById("mainContainer");
if (pageContainer) {
WinJS.Utilities.addClass(pageContainer, "tianQi");
}
},
clearPageClass: function clearPageClass() {
var pageContainer = document.getElementById("mainContainer");
if (pageContainer) {
WinJS.Utilities.removeClass(pageContainer, "tianQi");
}
},
getPageData: function getPageData(page) {
var that = page;
var pageTitle;
var defaultLocation = WeatherAppJS.LocationsManager.getDefaultLocation();
var isFre = (WeatherAppJS.SettingsManager.isFRE() || !defaultLocation);
if (isFre) {
// China FRE
WeatherAppJS.Utilities.UI.disableNavigationBar();
WeatherAppJS.Utilities.UI.disableBottomEdgy("homeEdgy");
that.freScenario();
var presetDefaultLocation = WeatherAppJS.Utilities.Common.getPresetDefaultLocation();
that._locID = presetDefaultLocation.getId();
var locationDisplayName = presetDefaultLocation.getShortDisplayName(that._locID);
pageTitle = PlatformJS.Services.resourceLoader.getString("SampleDataHeader").format(locationDisplayName);
} else {
// Show top navigation bar and edgies which would have been hidden in FRE. 
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
WeatherAppJS.Utilities.UI.enableNavigationBar();
WeatherAppJS.Utilities.UI.enableBottomEdgy("homeEdgy");
pageTitle = WeatherAppJS.GeocodeCache.getShortDisplayName(that._locID);
}
var pageData = {
title: pageTitle,
panoramaState: {},
showInertiaBackground: true,
semanticZoomRenderer: WeatherAppJS.Utilities.Templates.getSemanticZoomTemplate
};
that._clusterDefs = [];
var bypassCache = (that._bypassCache) || false;
var dataQuery = WeatherAppJS.LocationsManager.getTianQiDataForLocationAsync;
var fragmentPath = "/panoramas/tianqi/template.html";
var p = WinJS.UI.Fragments.cache(fragmentPath);
return p.then(function () {
return dataQuery(that._locID, bypassCache, isFre);
}).then(function dataQueryComplete(locObj) {
that._lastUpdatedTime = locObj.getCurrentConditions().lastUpdatedTime;
that.displayLastUpdatedTime();
// Add Clusters to Page
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.heroOverview(that._locID, false /* bypassCache */, isFre, true));
var isHourlyClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("HourlyCluster");
if (isHourlyClusterEnabled && locObj.getCurrentConditions().isHourlyForecastAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.chinaHourlyForecast(that._locID, false /* bypassCache */, isFre));
}
var isMapsAvailable = locObj.getCurrentConditions().isMapsAvailable;
if (isMapsAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.maps(that._locID, bypassCache, isFre, true));
}
if (!isFre) {
var isNewsClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("NewsCluster");
if (isNewsClusterEnabled) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.chinaNewsCluster());
}
var isVideosClusterEnabled = Platform.Utilities.Globalization.isFeatureEnabled("VideosCluster");
if (isVideosClusterEnabled) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.chinaVideoCluster());
}
}
var isTripPlanAvailable = locObj.getCurrentConditions().isTripPlanAvailable;
if (isTripPlanAvailable) {
that.pushIntoClusterDefs(WeatherAppJS.Configs.Cluster.historical(that._locID, bypassCache, isFre));
}
}, function dataQueryError(err) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
if (PlatformJS.Utilities.isPromiseCanceled(err)) {
return WinJS.Promise.wrapError(err);
}
// show full screen error...
var errorType = (WeatherAppJS.Networking.internetAvailable === true) ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
CommonJS.Error.showError(errorType, function () {
that.onPageRefresh(that._bypassCache);
});
}).then(function () {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
that._data = new WinJS.Binding.List(that._clusterDefs);
that.addNextStepsCluster();
pageData.clusterDataSource = that._data.dataSource;
return pageData;
});
},
firstViewRealized: function firstViewRealized(page) {
},
});
})(WinJS);